#include <string.h>

#include "ZBFGApplication.h"

//============================================
ZFilePanel::ZFilePanel()
	: BFilePanel(B_OPEN_PANEL, NULL, NULL, B_DIRECTORY_NODE, false, NULL, NULL, false, true)
{
	BView* aview;

	if (Window()->Lock())
	{
		BView* cancel = Window()->FindView("cancel button");
		
		if (cancel) //make sure cancel button exists
		{
			// add Open File button
			aview = Window()->ChildAt(0); // get the background view
			if (aview)
			{
				BRect arect(cancel->Frame());
				arect.OffsetBy(-(arect.left - aview->Bounds().left - 10),0); // position button to left of window
				
				single_file_button = new BButton(arect,"openbutton","Select File", 
												new BMessage(OPEN_FILE_MSG),B_FOLLOW_LEFT|B_FOLLOW_BOTTOM);
				single_file_button->SetTarget(be_app); 
				single_file_button->SetEnabled(false);
				aview->AddChild(single_file_button);
			}
		}

		Window()->Unlock();
	}

	SetButtonLabel(B_DEFAULT_BUTTON,"Select Directory");
	Window()->SetTitle("Select search File or a Directory");
}

//==========================================
ZFilePanel::~ZFilePanel(void)
{
}

//===========================================
// High-light open button when image selected
void ZFilePanel::SelectionChanged(void)
{
	status_t err;
	char *tstr = new char[B_MIME_TYPE_LENGTH];
	bool file_selected=false;
	
	Rewind();
	err = GetNextSelectedRef(&zv_ref);
	if (err == B_OK) {
		BNode node(&zv_ref);
		if (!node.IsDirectory())
		{
			file_selected = true;	
		}
	}	
	single_file_button->SetEnabled(file_selected);
	delete tstr;
}

//==============================
void ZFilePanel::FileSelected()
{
/*
	BPath path(&zv_ref);
	
	delete_list();
	zv_listwindow->EmptyList();
	
	add_to_list(path.Path()); 
	zv_listwindow->AddItem(list_navigation->tail->bstring);
	list_navigation->position = list_navigation->head;
*/
}	 