// Linked list, written by Zenja Solaja, December 2000
#include "ZBFGApplication.h"
#include <cstring>
#include <cstdio>

//============================
bool add_to_list(const char *buffer, int line, bool directory_flag)
{
	int len;
	char *display_line = new char [FILEBUFFER_SIZE + 7];
		
	MATCH *member = new MATCH;
	if (!member) 
		return false;
	
	len = strlen(buffer);
	if (len == 0)
		return false;
		
	member->contents = new char[len+1];
	if (!member->contents)
		return false;
			 
	strcpy(member->contents, buffer); 
	member->line_number = line;
	member->is_directory = directory_flag;
		
	sprintf(display_line, "%4d", line);
	strcat(display_line, "   ");
	strcat(display_line, buffer);
						
	if (directory_flag)
	{
		BPath aPath(buffer, NULL, false);
		member->bstring = new BStringItem(aPath.Path(), 0, true);
	}
	else
		member->bstring = new BStringItem(display_line, 0, true);	
	
	match_list[num_items_in_list] = member;
	num_items_in_list++;
	delete [] display_line;
	return true;  //success
}

//=============================
void remove_last_list_item()
{
	if (num_items_in_list <= 0) //insanity check
		return;	
	
	MATCH *where = match_list[num_items_in_list-1];
	if (where == NULL) //insanity check
		return;
		
	delete [] where->contents;
	delete where;
	num_items_in_list--;
}

//=============================
void delete_list()
{
	if (num_items_in_list <=0)
		return; //nothing to do
	
	while ((volatile int)num_items_in_list)
		remove_last_list_item();
}

		